﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=12.5
@EndOfDesignText@
'ComboBoxCloneNet
#Event: Click()
#Event: DropDown()
#Event: DropDownClosed()
#Event: FocusChanged(HasFocus As Boolean)
#Event: SelectedIndexChanged(Index As Int)
#Event: SelectedDisplayChanged(Display As String)
#Event: SelectedValueChanged(Value As String)
#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private xui As XUI 'ignore
	Public mBase As B4XView
	Public Tag As Object
	Private mDataSource As Map
	Private txtCombo As B4XFloatTextField
	Public HintText As String
	'Type MyType(val1 As Long, val2 As String)
	Private blnDropDown As Boolean = False
	Private imgDropDown As B4XImageView
End Sub

public Sub imgDropDown_click()
	If blnDropDown = True Then
		blnDropDown = False
		'TODO: Hide list of Display Values
		'Raise event
		Trigger_DropDownClosed
	Else
		blnDropDown = True
		'TODO: Show list of Display Values
		'Raise event
		Trigger_DropDown
	End If
End Sub

#Region "Triggers"
Sub Trigger_DropDown()
	If SubExists(mCallBack, mEventName & "_DropDown") Then
		CallSubDelayed(mCallBack, mEventName & "_DropDown")
	End If
End Sub
Sub Trigger_DropDownClosed()
	If SubExists(mCallBack, mEventName & "_DropDownClosed") Then
		CallSubDelayed(mCallBack, mEventName & "_DropDownClosed")
  End If
End Sub
#End Region



Public Sub Initialize(Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	mDataSource.Initialize
	mBase.Height = 30dip
	txtCombo.Initialize(mCallBack, mEventName)
	imgDropDown.Initialize(mCallBack, mEventName)
End Sub

'Base type must be Object
Public Sub DesignerCreateView(Base As Object, Lbl As Label, Props As Map)
	mBase = Base
  Tag = mBase.Tag
  mBase.Tag = Me 
End Sub

Private Sub Base_Resize(Width As Double, Height As Double)

End Sub

#Region "B4XFloatTextField - txtCombo"
Public Sub txtCombo_FocusChanged(HasFocus As Boolean)
	
End Sub
#End Region

Public Sub Hint(Text As String)
	HintText = Text
	txtCombo.HintText = HintText
End Sub

#Region "Map handler"
'Get all map
public Sub GetItems() As Map
	Return mDataSource 
End Sub

'Set map
Public Sub SetItems(DataSource As Map)
	mDataSource.Clear
	mDataSource = DataSource
End Sub

Public Sub Add(Key As String, DisplayValue As String) As Boolean
	If mDataSource.ContainsKey(Key) Then
		Return False
	Else
		mDataSource.Put(Key, DisplayValue)
		Return True
	End If
End Sub

Public Sub Clear()
	mDataSource.Clear
End Sub

Public Sub Item(Key As String) As String
	If Not (mDataSource.ContainsKey(Key)) Then
		Return ""
	Else
		Return mDataSource.Get(Key)
	End If
End Sub

Public Sub Remove(Key As String) As Boolean
	If Not (mDataSource.ContainsKey(Key)) Then
		Return False
	Else
		mDataSource.Remove(Key)
		Return True
	End If
End Sub
#End Region
